
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         aalogparse_parse
#define yylex           aalogparse_lex
#define yyerror         aalogparse_error
#define yylval          aalogparse_lval
#define yychar          aalogparse_char
#define yydebug         aalogparse_debug
#define yynerrs         aalogparse_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 19 "grammar.y"


#define YYDEBUG 0
#include <string.h>
#include "aalogparse.h"
#include "parser.h"
#include "grammar.h"
#include "scanner.h"

aa_log_record *ret_record;

/* Since we're a library, on any errors we don't want to print out any
 * error messages. We should probably add a debug interface that does
 * emit messages when asked for. */
void aalogparse_error(void *scanner, char const *s)
{
        //printf("ERROR: %s\n", s);
	ret_record->event = AA_RECORD_INVALID;
}

struct aa_type_table {
	unsigned int audit_type;
	aa_record_event_type event;
};

static struct aa_type_table aa_type_table[] = {
	{AUDIT_APPARMOR_AUDIT,   AA_RECORD_AUDIT},
	{AUDIT_APPARMOR_ALLOWED, AA_RECORD_ALLOWED},
	{AUDIT_APPARMOR_DENIED,  AA_RECORD_DENIED},
	{AUDIT_APPARMOR_HINT,    AA_RECORD_HINT},
	{AUDIT_APPARMOR_STATUS,  AA_RECORD_STATUS},
	{AUDIT_APPARMOR_ERROR,   AA_RECORD_ERROR},
	{0,                      AA_RECORD_INVALID},
};

aa_record_event_type lookup_aa_event(unsigned int type)
{
	int i;

	for (i = 0; aa_type_table[i].audit_type != 0; i++)
		if (type == aa_type_table[i].audit_type)
			break;

	return aa_type_table[i].event;
}




/* Line 189 of yacc.c  */
#line 131 "grammar.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_DIGITS = 258,
     TOK_TYPE_UNKNOWN = 259,
     TOK_QUOTED_STRING = 260,
     TOK_PATH = 261,
     TOK_ID = 262,
     TOK_NULL_COMPLAIN = 263,
     TOK_MODE = 264,
     TOK_DMESG_STAMP = 265,
     TOK_SINGLE_QUOTED_STRING = 266,
     TOK_AUDIT_DIGITS = 267,
     TOK_DATE_MONTH = 268,
     TOK_DATE_TIME = 269,
     TOK_HEXSTRING = 270,
     TOK_TYPE_OTHER = 271,
     TOK_MSG_REST = 272,
     TOK_EQUALS = 273,
     TOK_COLON = 274,
     TOK_OPEN_PAREN = 275,
     TOK_CLOSE_PAREN = 276,
     TOK_PERIOD = 277,
     TOK_TYPE_REJECT = 278,
     TOK_TYPE_AUDIT = 279,
     TOK_TYPE_COMPLAIN = 280,
     TOK_TYPE_HINT = 281,
     TOK_TYPE_STATUS = 282,
     TOK_TYPE_ERROR = 283,
     TOK_OLD_TYPE_APPARMOR = 284,
     TOK_OLD_APPARMOR_REJECT = 285,
     TOK_OLD_APPARMOR_PERMIT = 286,
     TOK_OLD_APPARMOR_AUDIT = 287,
     TOK_OLD_APPARMOR_LOGPROF_HINT = 288,
     TOK_OLD_UNKNOWN_HAT = 289,
     TOK_OLD_ACTIVE = 290,
     TOK_OLD_UNKNOWN_PROFILE = 291,
     TOK_OLD_MISSING_PROFILE = 292,
     TOK_OLD_CHANGING_PROFILE = 293,
     TOK_OLD_ACCESS = 294,
     TOK_OLD_TO = 295,
     TOK_OLD_FROM = 296,
     TOK_OLD_PIPE = 297,
     TOK_OLD_EXTENDED = 298,
     TOK_OLD_ATTRIBUTE = 299,
     TOK_OLD_ON = 300,
     TOK_OLD_MKDIR = 301,
     TOK_OLD_RMDIR = 302,
     TOK_OLD_XATTR = 303,
     TOK_OLD_CHANGE = 304,
     TOK_OLD_CAPABILITY = 305,
     TOK_OLD_SYSCALL = 306,
     TOK_OLD_LINK = 307,
     TOK_OLD_FORK = 308,
     TOK_OLD_CHILD = 309,
     TOK_KEY_TYPE = 310,
     TOK_KEY_MSG = 311,
     TOK_KEY_OPERATION = 312,
     TOK_KEY_NAME = 313,
     TOK_KEY_NAME2 = 314,
     TOK_KEY_DENIED_MASK = 315,
     TOK_KEY_REQUESTED_MASK = 316,
     TOK_KEY_ATTRIBUTE = 317,
     TOK_KEY_TASK = 318,
     TOK_KEY_PARENT = 319,
     TOK_KEY_MAGIC_TOKEN = 320,
     TOK_KEY_INFO = 321,
     TOK_KEY_PID = 322,
     TOK_KEY_PROFILE = 323,
     TOK_AUDIT = 324,
     TOK_KEY_IMAGE = 325,
     TOK_KEY_FAMILY = 326,
     TOK_KEY_SOCK_TYPE = 327,
     TOK_KEY_PROTOCOL = 328,
     TOK_KEY_NAMESPACE = 329,
     TOK_KEY_ERROR = 330,
     TOK_KEY_FSUID = 331,
     TOK_SYSLOG_KERNEL = 332
   };
#endif
/* Tokens.  */
#define TOK_DIGITS 258
#define TOK_TYPE_UNKNOWN 259
#define TOK_QUOTED_STRING 260
#define TOK_PATH 261
#define TOK_ID 262
#define TOK_NULL_COMPLAIN 263
#define TOK_MODE 264
#define TOK_DMESG_STAMP 265
#define TOK_SINGLE_QUOTED_STRING 266
#define TOK_AUDIT_DIGITS 267
#define TOK_DATE_MONTH 268
#define TOK_DATE_TIME 269
#define TOK_HEXSTRING 270
#define TOK_TYPE_OTHER 271
#define TOK_MSG_REST 272
#define TOK_EQUALS 273
#define TOK_COLON 274
#define TOK_OPEN_PAREN 275
#define TOK_CLOSE_PAREN 276
#define TOK_PERIOD 277
#define TOK_TYPE_REJECT 278
#define TOK_TYPE_AUDIT 279
#define TOK_TYPE_COMPLAIN 280
#define TOK_TYPE_HINT 281
#define TOK_TYPE_STATUS 282
#define TOK_TYPE_ERROR 283
#define TOK_OLD_TYPE_APPARMOR 284
#define TOK_OLD_APPARMOR_REJECT 285
#define TOK_OLD_APPARMOR_PERMIT 286
#define TOK_OLD_APPARMOR_AUDIT 287
#define TOK_OLD_APPARMOR_LOGPROF_HINT 288
#define TOK_OLD_UNKNOWN_HAT 289
#define TOK_OLD_ACTIVE 290
#define TOK_OLD_UNKNOWN_PROFILE 291
#define TOK_OLD_MISSING_PROFILE 292
#define TOK_OLD_CHANGING_PROFILE 293
#define TOK_OLD_ACCESS 294
#define TOK_OLD_TO 295
#define TOK_OLD_FROM 296
#define TOK_OLD_PIPE 297
#define TOK_OLD_EXTENDED 298
#define TOK_OLD_ATTRIBUTE 299
#define TOK_OLD_ON 300
#define TOK_OLD_MKDIR 301
#define TOK_OLD_RMDIR 302
#define TOK_OLD_XATTR 303
#define TOK_OLD_CHANGE 304
#define TOK_OLD_CAPABILITY 305
#define TOK_OLD_SYSCALL 306
#define TOK_OLD_LINK 307
#define TOK_OLD_FORK 308
#define TOK_OLD_CHILD 309
#define TOK_KEY_TYPE 310
#define TOK_KEY_MSG 311
#define TOK_KEY_OPERATION 312
#define TOK_KEY_NAME 313
#define TOK_KEY_NAME2 314
#define TOK_KEY_DENIED_MASK 315
#define TOK_KEY_REQUESTED_MASK 316
#define TOK_KEY_ATTRIBUTE 317
#define TOK_KEY_TASK 318
#define TOK_KEY_PARENT 319
#define TOK_KEY_MAGIC_TOKEN 320
#define TOK_KEY_INFO 321
#define TOK_KEY_PID 322
#define TOK_KEY_PROFILE 323
#define TOK_AUDIT 324
#define TOK_KEY_IMAGE 325
#define TOK_KEY_FAMILY 326
#define TOK_KEY_SOCK_TYPE 327
#define TOK_KEY_PROTOCOL 328
#define TOK_KEY_NAMESPACE 329
#define TOK_KEY_ERROR 330
#define TOK_KEY_FSUID 331
#define TOK_SYSLOG_KERNEL 332




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 74 "grammar.y"

	char	*t_str;
	long	t_long;



/* Line 214 of yacc.c  */
#line 328 "grammar.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 340 "grammar.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  13
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   279

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  78
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  31
/* YYNRULES -- Number of rules.  */
#define YYNRULES  86
/* YYNRULES -- Number of states.  */
#define YYNSTATES  251

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   332

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    13,    15,    17,    19,
      23,    27,    31,    35,    39,    43,    47,    51,    55,    59,
      65,    71,    78,    85,    93,    94,   100,   103,   106,   108,
     110,   112,   119,   126,   134,   145,   153,   161,   171,   173,
     175,   181,   186,   189,   192,   195,   204,   206,   209,   214,
     219,   222,   229,   230,   237,   239,   241,   243,   247,   257,
     261,   263,   266,   270,   274,   278,   282,   286,   290,   294,
     298,   302,   306,   310,   312,   316,   320,   324,   328,   332,
     336,   340,   344,   348,   350,   352,   354
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      79,     0,    -1,    80,    -1,    85,    -1,    86,    -1,    55,
      18,    81,    -1,    82,    -1,    83,    -1,    84,    -1,    29,
     100,    88,    -1,     4,   100,    88,    -1,    23,   100,   103,
      -1,    24,   100,   103,    -1,    25,   100,   103,    -1,    26,
     100,   103,    -1,    27,   100,   103,    -1,    28,   100,   103,
      -1,     4,   100,   103,    -1,    16,   100,    17,    -1,   102,
       7,    77,   101,    88,    -1,   102,     7,    77,   101,   103,
      -1,   102,     7,    77,   106,   101,   103,    -1,   102,     7,
      77,    10,   101,   103,    -1,   102,     7,    77,    10,   106,
     101,   103,    -1,    -1,   100,    88,    87,   100,   103,    -1,
      89,    90,    -1,    33,    95,    -1,    30,    -1,    31,    -1,
      32,    -1,     9,    39,    94,    20,    92,    21,    -1,    91,
      45,     6,    20,    92,    21,    -1,    48,     7,    45,     6,
      20,    92,    21,    -1,    62,    20,     7,    21,    49,    40,
       6,    20,    92,    21,    -1,    39,    40,    50,    11,    20,
      92,    21,    -1,    39,    40,    51,    11,    20,    92,    21,
      -1,    52,    39,    41,     6,    40,     6,    20,    92,    21,
      -1,    46,    -1,    47,    -1,     7,    20,     7,    21,    93,
      -1,    68,    99,    35,    99,    -1,    40,     6,    -1,    40,
      42,    -1,    43,    62,    -1,    96,   105,    68,    18,    99,
      35,    18,    99,    -1,    97,    -1,    38,   105,    -1,    36,
      70,    18,     7,    -1,    37,    70,    18,     7,    -1,    34,
       7,    -1,    53,   105,    54,    18,     3,    98,    -1,    -1,
      68,    18,    99,    35,    18,    99,    -1,     6,    -1,     7,
      -1,     8,    -1,    56,    18,   101,    -1,    69,    20,    12,
      22,    12,    19,    12,    21,    19,    -1,    13,     3,    14,
      -1,   104,    -1,   103,   104,    -1,    57,    18,     5,    -1,
      58,    18,   107,    -1,    74,    18,   107,    -1,    59,    18,
     107,    -1,    60,    18,     5,    -1,    61,    18,     5,    -1,
      62,    18,     5,    -1,    63,    18,     3,    -1,    64,    18,
       3,    -1,    65,    18,     3,    -1,    66,    18,     5,    -1,
     105,    -1,    68,    18,   107,    -1,    71,    18,     5,    -1,
      72,    18,     5,    -1,    73,    18,   108,    -1,    55,    18,
       3,    -1,    75,    18,     3,    -1,    76,    18,     3,    -1,
      67,    18,     3,    -1,    55,    18,     3,    -1,     5,    -1,
      15,    -1,     5,    -1,     3,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   151,   151,   152,   153,   156,   158,   159,   160,   163,
     164,   168,   169,   170,   171,   172,   173,   174,   177,   186,
     188,   190,   192,   194,   200,   200,   205,   206,   210,   211,
     212,   216,   222,   227,   234,   242,   248,   254,   264,   265,
     269,   278,   285,   289,   293,   299,   307,   308,   313,   320,
     327,   338,   346,   348,   356,   357,   358,   361,   364,   374,
     377,   378,   381,   383,   385,   387,   389,   391,   393,   395,
     397,   399,   401,   403,   404,   406,   408,   410,   412,   414,
     416,   420,   423,   426,   427,   430,   431
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_DIGITS", "TOK_TYPE_UNKNOWN",
  "TOK_QUOTED_STRING", "TOK_PATH", "TOK_ID", "TOK_NULL_COMPLAIN",
  "TOK_MODE", "TOK_DMESG_STAMP", "TOK_SINGLE_QUOTED_STRING",
  "TOK_AUDIT_DIGITS", "TOK_DATE_MONTH", "TOK_DATE_TIME", "TOK_HEXSTRING",
  "TOK_TYPE_OTHER", "TOK_MSG_REST", "TOK_EQUALS", "TOK_COLON",
  "TOK_OPEN_PAREN", "TOK_CLOSE_PAREN", "TOK_PERIOD", "TOK_TYPE_REJECT",
  "TOK_TYPE_AUDIT", "TOK_TYPE_COMPLAIN", "TOK_TYPE_HINT",
  "TOK_TYPE_STATUS", "TOK_TYPE_ERROR", "TOK_OLD_TYPE_APPARMOR",
  "TOK_OLD_APPARMOR_REJECT", "TOK_OLD_APPARMOR_PERMIT",
  "TOK_OLD_APPARMOR_AUDIT", "TOK_OLD_APPARMOR_LOGPROF_HINT",
  "TOK_OLD_UNKNOWN_HAT", "TOK_OLD_ACTIVE", "TOK_OLD_UNKNOWN_PROFILE",
  "TOK_OLD_MISSING_PROFILE", "TOK_OLD_CHANGING_PROFILE", "TOK_OLD_ACCESS",
  "TOK_OLD_TO", "TOK_OLD_FROM", "TOK_OLD_PIPE", "TOK_OLD_EXTENDED",
  "TOK_OLD_ATTRIBUTE", "TOK_OLD_ON", "TOK_OLD_MKDIR", "TOK_OLD_RMDIR",
  "TOK_OLD_XATTR", "TOK_OLD_CHANGE", "TOK_OLD_CAPABILITY",
  "TOK_OLD_SYSCALL", "TOK_OLD_LINK", "TOK_OLD_FORK", "TOK_OLD_CHILD",
  "TOK_KEY_TYPE", "TOK_KEY_MSG", "TOK_KEY_OPERATION", "TOK_KEY_NAME",
  "TOK_KEY_NAME2", "TOK_KEY_DENIED_MASK", "TOK_KEY_REQUESTED_MASK",
  "TOK_KEY_ATTRIBUTE", "TOK_KEY_TASK", "TOK_KEY_PARENT",
  "TOK_KEY_MAGIC_TOKEN", "TOK_KEY_INFO", "TOK_KEY_PID", "TOK_KEY_PROFILE",
  "TOK_AUDIT", "TOK_KEY_IMAGE", "TOK_KEY_FAMILY", "TOK_KEY_SOCK_TYPE",
  "TOK_KEY_PROTOCOL", "TOK_KEY_NAMESPACE", "TOK_KEY_ERROR",
  "TOK_KEY_FSUID", "TOK_SYSLOG_KERNEL", "$accept", "log_message",
  "audit_type", "type_syntax", "old_syntax", "new_syntax", "other_audit",
  "syslog_type", "audit_dispatch", "$@1", "old_msg",
  "old_permit_reject_type", "old_permit_reject_syntax", "dir_action",
  "old_process_state", "old_profile_names",
  "old_permit_reject_path_pipe_extended", "old_logprof_syntax",
  "old_logprof_syntax2", "old_logprof_fork_syntax",
  "old_logprof_fork_addition", "old_profile", "audit_msg", "audit_id",
  "syslog_date", "key_list", "key", "key_pid", "key_type", "safe_string",
  "protocol", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    78,    79,    79,    79,    80,    81,    81,    81,    82,
      82,    83,    83,    83,    83,    83,    83,    83,    84,    85,
      85,    85,    85,    85,    87,    86,    88,    88,    89,    89,
      89,    90,    90,    90,    90,    90,    90,    90,    91,    91,
      92,    93,    94,    94,    94,    95,    95,    95,    96,    96,
      96,    97,    98,    98,    99,    99,    99,   100,   101,   102,
     103,   103,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   105,   106,   107,   107,   108,   108
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     3,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     5,
       5,     6,     6,     7,     0,     5,     2,     2,     1,     1,
       1,     6,     6,     7,    10,     7,     7,     9,     1,     1,
       5,     4,     2,     2,     2,     8,     1,     2,     4,     4,
       2,     6,     0,     6,     1,     1,     1,     3,     9,     3,
       1,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     2,     3,     4,     0,     0,
       0,     0,     0,     1,    28,    29,    30,     0,    24,     0,
       0,    59,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     5,     6,     7,     8,     0,    57,     0,     0,     0,
       0,     0,    27,     0,    46,     0,     0,     0,    38,    39,
       0,     0,     0,    26,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    50,     0,     0,     0,
      47,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    10,    17,    60,    73,    18,    11,    12,    13,
      14,    15,    16,     9,     0,     0,     0,     0,     0,     0,
      25,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    19,    20,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    61,     0,    48,    49,    81,     0,
       0,    42,    43,    44,     0,     0,     0,     0,     0,     0,
       0,    22,     0,    82,    21,    78,    62,    83,    84,    63,
      65,    66,    67,    68,    69,    70,    71,    72,    74,    75,
      76,    86,    85,    77,    64,    79,    80,     0,    52,    54,
      55,    56,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    23,     0,     0,    51,     0,     0,    31,     0,     0,
       0,     0,     0,    32,     0,     0,     0,     0,    35,    36,
      33,     0,     0,     0,     0,    45,     0,     0,     0,    58,
       0,     0,    40,    37,     0,     0,     0,    34,    53,     0,
      41
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     4,     5,    31,    32,    33,    34,     6,     7,    45,
      18,    19,    53,    54,   204,   242,   123,    42,    43,    44,
     214,   202,     8,    36,     9,   103,   104,   105,    83,   179,
     193
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -161
static const yytype_int16 yypact[] =
{
       0,     5,    -4,    14,    40,  -161,  -161,  -161,    37,    35,
      30,   102,   -16,  -161,  -161,  -161,  -161,    85,  -161,     2,
     -20,  -161,     7,     7,     7,     7,     7,     7,     7,     7,
       7,  -161,  -161,  -161,  -161,    45,  -161,    68,     9,    11,
      18,    18,  -161,    18,  -161,     7,    59,    69,  -161,  -161,
      92,    76,    88,  -161,    79,    -3,    29,   116,    95,    95,
      95,    95,    95,    95,    37,   122,  -161,   117,   121,   133,
    -161,    83,    97,    95,    67,   -13,   127,   132,   167,   169,
     -46,   158,    29,   -16,   159,   160,   161,   162,   163,   164,
     165,   166,   168,   170,   171,   172,   173,   174,   175,   176,
     177,   178,  -161,    95,  -161,  -161,  -161,    95,    95,    95,
      95,    95,    95,  -161,   179,   180,   190,   182,   181,   184,
      95,    16,   136,   183,   189,   193,   199,   200,   186,   188,
      95,   -16,   206,  -161,    95,    95,   207,   208,    21,    21,
     209,   210,   211,   214,   215,   216,   217,    21,   218,   219,
      25,    21,   222,   223,  -161,   220,  -161,  -161,  -161,   224,
     105,  -161,  -161,  -161,   204,   192,   201,   213,   191,   185,
     204,    95,    95,  -161,    95,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,   221,   152,  -161,
    -161,  -161,   194,   225,   226,   204,   204,   204,   229,   196,
     227,    95,   230,   212,  -161,   228,   231,  -161,   232,   233,
     234,   236,   235,  -161,   237,   105,   105,   238,  -161,  -161,
    -161,   204,   240,   242,   202,  -161,   195,   241,   204,  -161,
     239,   105,  -161,  -161,   243,   105,   244,  -161,  -161,   105,
    -161
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
     -31,  -161,  -161,  -161,  -160,  -161,  -161,  -161,  -161,  -161,
    -161,  -109,   119,   -49,  -161,   -58,   -91,    33,   148,  -112,
    -161
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
     107,   108,   109,   110,   111,   112,    82,    80,    10,    81,
     210,    46,   154,     1,    11,   120,   154,   154,   154,   154,
     154,   154,   161,    35,   134,   102,   177,   180,   191,   154,
     192,   130,    12,   113,   135,   188,   178,   124,   125,   194,
      13,    47,    20,   154,    21,   218,   219,   220,    48,    49,
      50,   133,    81,    35,    51,     2,     3,    55,   162,    14,
      15,    16,    17,     3,    52,    65,    35,    14,    15,    16,
      17,   237,   171,    70,    71,    66,    72,   174,   244,    67,
     154,    68,   172,   154,    84,    69,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    69,    95,    74,    76,
      96,    97,    98,    99,   100,   101,    22,   121,    78,    75,
     122,   199,   200,   201,   211,    77,   234,   235,    23,    37,
     154,    38,    39,    40,    79,    24,    25,    26,    27,    28,
      29,    30,   246,   106,   114,   115,   248,   118,    41,   116,
     250,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      84,   117,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    69,    95,    73,   119,    96,    97,    98,    99,
     100,   101,   126,   127,   128,   129,   132,   136,   137,   138,
     139,   140,   141,   142,   143,   158,   144,   156,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   157,   163,   159,
     165,   155,   160,   164,   166,   167,   168,   169,   170,   173,
     175,   203,   205,   176,   181,   182,   183,   184,   185,   186,
     213,   206,   187,   189,   190,   195,   196,   198,   131,   215,
     225,   208,   197,   207,   209,   221,   222,   240,   227,     0,
     212,   232,   224,     0,     0,   216,   226,   217,   223,     0,
       0,     0,     0,   228,   229,   230,   231,   245,   233,   236,
     238,   239,   243,   241,   247,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   249
};

static const yytype_int16 yycheck[] =
{
      58,    59,    60,    61,    62,    63,    55,    10,     3,    55,
     170,     9,   103,    13,    18,    73,   107,   108,   109,   110,
     111,   112,     6,    69,    82,    56,     5,   139,     3,   120,
       5,    80,    18,    64,    83,   147,    15,    50,    51,   151,
       0,    39,     7,   134,    14,   205,   206,   207,    46,    47,
      48,    82,    55,    69,    52,    55,    56,    77,    42,    30,
      31,    32,    33,    56,    62,    20,    69,    30,    31,    32,
      33,   231,   130,    40,    41,     7,    43,   135,   238,    70,
     171,    70,   131,   174,    55,    67,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    39,     7,
      71,    72,    73,    74,    75,    76,     4,    40,    20,    40,
      43,     6,     7,     8,   172,    39,   225,   226,    16,    34,
     211,    36,    37,    38,    45,    23,    24,    25,    26,    27,
      28,    29,   241,    17,    12,    18,   245,    54,    53,    18,
     249,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      55,    18,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    45,    68,    71,    72,    73,    74,
      75,    76,    45,    41,     7,     6,    18,    18,    18,    18,
      18,    18,    18,    18,    18,     3,    18,     7,    18,    18,
      18,    18,    18,    18,    18,    18,    18,     7,    62,    18,
      11,    22,    18,    20,    11,     6,     6,    21,    20,     3,
       3,     7,    20,     5,     5,     5,     5,     3,     3,     3,
      68,    20,     5,     5,     5,     3,     3,     3,    80,    35,
      18,    40,    12,    20,    49,     6,    40,    35,     7,    -1,
      19,     6,    12,    -1,    -1,    20,    18,    21,    21,    -1,
      -1,    -1,    -1,    21,    21,    21,    20,    18,    21,    21,
      20,    19,    21,    68,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    13,    55,    56,    79,    80,    85,    86,   100,   102,
       3,    18,    18,     0,    30,    31,    32,    33,    88,    89,
       7,    14,     4,    16,    23,    24,    25,    26,    27,    28,
      29,    81,    82,    83,    84,    69,   101,    34,    36,    37,
      38,    53,    95,    96,    97,    87,     9,    39,    46,    47,
      48,    52,    62,    90,    91,    77,   100,   100,   100,   100,
     100,   100,   100,   100,   100,    20,     7,    70,    70,    67,
     105,   105,   105,   100,    39,    40,     7,    39,    20,    45,
      10,    55,   101,   106,    55,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    68,    71,    72,    73,    74,
      75,    76,    88,   103,   104,   105,    17,   103,   103,   103,
     103,   103,   103,    88,    12,    18,    18,    18,    54,    68,
     103,    40,    43,    94,    50,    51,    45,    41,     7,     6,
     101,   106,    18,    88,   103,   101,    18,    18,    18,    18,
      18,    18,    18,    18,    18,    18,    18,    18,    18,    18,
      18,    18,    18,    18,   104,    22,     7,     7,     3,    18,
      18,     6,    42,    62,    20,    11,    11,     6,     6,    21,
      20,   103,   101,     3,   103,     3,     5,     5,    15,   107,
     107,     5,     5,     5,     3,     3,     3,     5,   107,     5,
       5,     3,     5,   108,   107,     3,     3,    12,     3,     6,
       7,     8,    99,     7,    92,    20,    20,    20,    40,    49,
      92,   103,    19,    68,    98,    35,    20,    21,    92,    92,
      92,     6,    40,    21,    12,    18,    18,     7,    21,    21,
      21,    20,     6,    21,    99,    99,    21,    92,    20,    19,
      35,    68,    93,    21,    92,    18,    99,    21,    99,    35,
      99
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (scanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, scanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, scanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, void *scanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, scanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    void *scanner;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (scanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, void *scanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, scanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    void *scanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, scanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule, void *scanner)
#else
static void
yy_reduce_print (yyvsp, yyrule, scanner)
    YYSTYPE *yyvsp;
    int yyrule;
    void *scanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       , scanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule, scanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, void *scanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, scanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    void *scanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (scanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void *scanner);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *scanner)
#else
int
yyparse (scanner)
    void *scanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:

/* Line 1455 of yacc.c  */
#line 158 "grammar.y"
    { ret_record->version = AA_RECORD_SYNTAX_V1; }
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 159 "grammar.y"
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 168 "grammar.y"
    { ret_record->event = AA_RECORD_DENIED; }
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 169 "grammar.y"
    { ret_record->event = AA_RECORD_AUDIT; }
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 170 "grammar.y"
    { ret_record->event = AA_RECORD_ALLOWED; }
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 171 "grammar.y"
    { ret_record->event = AA_RECORD_HINT; }
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 172 "grammar.y"
    { ret_record->event = AA_RECORD_STATUS; }
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 173 "grammar.y"
    { ret_record->event = AA_RECORD_ERROR; }
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 174 "grammar.y"
    { ret_record->event = lookup_aa_event((yyvsp[(1) - (3)].t_long)); }
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 178 "grammar.y"
    {
		ret_record->operation = (yyvsp[(1) - (3)].t_str);
		ret_record->event = AA_RECORD_INVALID;
		ret_record->info = (yyvsp[(3) - (3)].t_str);
	}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 187 "grammar.y"
    { ret_record->version = AA_RECORD_SYNTAX_V1; }
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 189 "grammar.y"
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 191 "grammar.y"
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 193 "grammar.y"
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 195 "grammar.y"
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 200 "grammar.y"
    { ret_record->version = AA_RECORD_SYNTAX_V1; }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 201 "grammar.y"
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 206 "grammar.y"
    { ret_record->event = AA_RECORD_HINT; }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 210 "grammar.y"
    { ret_record->event = AA_RECORD_DENIED; }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 211 "grammar.y"
    { ret_record->event = AA_RECORD_ALLOWED; }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 212 "grammar.y"
    { ret_record->event = AA_RECORD_AUDIT; }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 218 "grammar.y"
    {
		ret_record->requested_mask = (yyvsp[(1) - (6)].t_str);
		ret_record->operation = strdup("access");
	}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 224 "grammar.y"
    {
		ret_record->name = (yyvsp[(3) - (6)].t_str);
	}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 229 "grammar.y"
    {
		ret_record->operation = strdup("xattr");
		ret_record->attribute = (yyvsp[(2) - (7)].t_str);
		ret_record->name = (yyvsp[(4) - (7)].t_str);
	}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 237 "grammar.y"
    {
		ret_record->operation = strdup("setattr");
		ret_record->attribute = (yyvsp[(3) - (10)].t_str);
		ret_record->name = (yyvsp[(7) - (10)].t_str);
	}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 244 "grammar.y"
    {
		ret_record->operation = strdup("capability");
		ret_record->name = (yyvsp[(4) - (7)].t_str);
	}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 250 "grammar.y"
    {
		ret_record->operation = strdup("syscall");
		ret_record->name = (yyvsp[(4) - (7)].t_str);
	}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 256 "grammar.y"
    {
		ret_record->requested_mask = strdup("l");
		ret_record->name = (yyvsp[(4) - (9)].t_str);
		ret_record->name2 = (yyvsp[(6) - (9)].t_str);
	}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 264 "grammar.y"
    { ret_record->operation = strdup("mkdir"); }
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 265 "grammar.y"
    { ret_record->operation = strdup("rmdir"); }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 270 "grammar.y"
    {
		ret_record->info = (yyvsp[(1) - (5)].t_str);
		ret_record->pid = atol((yyvsp[(3) - (5)].t_str));
		free((yyvsp[(3) - (5)].t_str));
	}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 279 "grammar.y"
    {	ret_record->profile = (yyvsp[(2) - (4)].t_str);
		ret_record->active_hat = (yyvsp[(4) - (4)].t_str);
	}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 286 "grammar.y"
    {
			ret_record->name = (yyvsp[(2) - (2)].t_str);
		}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 290 "grammar.y"
    {
			ret_record->info = strdup("pipe");
		}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 294 "grammar.y"
    {
			ret_record->info = strdup("extended attribute");
		}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 301 "grammar.y"
    {
			ret_record->profile = strdup((yyvsp[(5) - (8)].t_str));
			free((yyvsp[(5) - (8)].t_str));
			ret_record->active_hat = strdup((yyvsp[(8) - (8)].t_str));
			free((yyvsp[(8) - (8)].t_str));
		}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 309 "grammar.y"
    { ret_record->profile = strdup("null-complain-profile"); }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 314 "grammar.y"
    {
			ret_record->operation = strdup("profile_set");
			ret_record->info = strdup("unknown profile");
			ret_record->name = strdup((yyvsp[(4) - (4)].t_str));
			free((yyvsp[(4) - (4)].t_str));
		}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 321 "grammar.y"
    {
			ret_record->operation = strdup("exec");
			ret_record->info = strdup("mandatory profile missing");
			ret_record->name = strdup((yyvsp[(4) - (4)].t_str));
			free((yyvsp[(4) - (4)].t_str));
		}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 328 "grammar.y"
    {
			ret_record->operation = strdup("change_hat");
			ret_record->name = strdup((yyvsp[(2) - (2)].t_str));
			free((yyvsp[(2) - (2)].t_str));
			ret_record->info = strdup("unknown_hat");
		}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 340 "grammar.y"
    {
		ret_record->operation = strdup("clone");
		ret_record->task = (yyvsp[(5) - (6)].t_long);
	}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 349 "grammar.y"
    {
		ret_record->profile = (yyvsp[(3) - (6)].t_str);
		ret_record->active_hat = (yyvsp[(6) - (6)].t_str);
	}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 356 "grammar.y"
    { (yyval.t_str) = (yyvsp[(1) - (1)].t_str); }
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 357 "grammar.y"
    { (yyval.t_str) = (yyvsp[(1) - (1)].t_str); }
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 358 "grammar.y"
    { (yyval.t_str) = strdup("null-complain-profile"); }
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 365 "grammar.y"
    {
		asprintf(&ret_record->audit_id, "%s.%s:%s", (yyvsp[(3) - (9)].t_str), (yyvsp[(5) - (9)].t_str), (yyvsp[(7) - (9)].t_str));
		ret_record->epoch = atol((yyvsp[(3) - (9)].t_str));
		ret_record->audit_sub_id = atoi((yyvsp[(7) - (9)].t_str));
		free((yyvsp[(3) - (9)].t_str));
		free((yyvsp[(5) - (9)].t_str));
		free((yyvsp[(7) - (9)].t_str));
	}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 374 "grammar.y"
    { /* do nothing? */ }
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 382 "grammar.y"
    { ret_record->operation = (yyvsp[(3) - (3)].t_str);}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 384 "grammar.y"
    { ret_record->name = (yyvsp[(3) - (3)].t_str);}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 386 "grammar.y"
    { ret_record->namespace = (yyvsp[(3) - (3)].t_str);}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 388 "grammar.y"
    { ret_record->name2 = (yyvsp[(3) - (3)].t_str);}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 390 "grammar.y"
    { ret_record->denied_mask = (yyvsp[(3) - (3)].t_str);}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 392 "grammar.y"
    { ret_record->requested_mask = (yyvsp[(3) - (3)].t_str);}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 394 "grammar.y"
    { ret_record->attribute = (yyvsp[(3) - (3)].t_str);}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 396 "grammar.y"
    { ret_record->task = (yyvsp[(3) - (3)].t_long);}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 398 "grammar.y"
    { ret_record->parent = (yyvsp[(3) - (3)].t_long);}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 400 "grammar.y"
    { ret_record->magic_token = (yyvsp[(3) - (3)].t_long);}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 402 "grammar.y"
    { ret_record->info = (yyvsp[(3) - (3)].t_str);}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 405 "grammar.y"
    { ret_record->profile = (yyvsp[(3) - (3)].t_str);}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 407 "grammar.y"
    { ret_record->net_family = (yyvsp[(3) - (3)].t_str);}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 409 "grammar.y"
    { ret_record->net_sock_type = (yyvsp[(3) - (3)].t_str);}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 411 "grammar.y"
    { ret_record->net_protocol = (yyvsp[(3) - (3)].t_str);}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 413 "grammar.y"
    { ret_record->event = lookup_aa_event((yyvsp[(3) - (3)].t_long));}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 415 "grammar.y"
    { ret_record->error_code = (yyvsp[(3) - (3)].t_long);}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 417 "grammar.y"
    { ret_record->fsuid = (yyvsp[(3) - (3)].t_long);}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 420 "grammar.y"
    { ret_record->pid = (yyvsp[(3) - (3)].t_long); }
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 423 "grammar.y"
    { ret_record->event = lookup_aa_event((yyvsp[(3) - (3)].t_long)); }
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 432 "grammar.y"
    { /* FIXME: this should probably convert back to a string proto name */
	  (yyval.t_str) = ipproto_to_string((yyvsp[(1) - (1)].t_long));
	}
    break;



/* Line 1455 of yacc.c  */
#line 2319 "grammar.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (scanner, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (scanner, yymsg);
	  }
	else
	  {
	    yyerror (scanner, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, scanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, scanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (scanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, scanner);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, scanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 436 "grammar.y"


aa_log_record *
_parse_yacc(char *str)
{
	/* yydebug = 1;  */
	YY_BUFFER_STATE lex_buf;
	yyscan_t scanner;
	int parser_return;

	ret_record = NULL;
	ret_record = (aa_log_record *) malloc(sizeof(aa_log_record));

	_init_log_record(ret_record);

	if (ret_record == NULL)
		return NULL;

	aalogparse_lex_init(&scanner);
	lex_buf = aalogparse__scan_string(str, scanner);
	parser_return = aalogparse_parse(scanner);
	aalogparse__delete_buffer(lex_buf, scanner);
	aalogparse_lex_destroy(scanner);
	return ret_record;
}

